<?php

# Disallow direct run of this script.
if (basename($_SERVER['PHP_SELF']) == "commands.php") 	{
	print("Direct execution of this script is not allowed.");
	exit;
}


# Includes
require_once("includes/drawlib.inc.php");

# Definitions
define("OBJECTTYPE", "command");
define("OBJECTNAME", "Command");
define("PAGE_INFO", 'Query made at '.date("H:i:s - d M Y"));

$rowcolor = '';
$rows = array();
$errormsg = '';
$message = '';
$commands = array ();

if (!isset($sorttype))	 $sorttype="0";
if (!isset($sortoption)) $sortoption=OBJECTTYPE."_name";
if (!isset($page)) 	 $page=1;

$sortoption = @strtolower($sortoption);

# Set Headers Titles and URL Values
$headers = array( 0 => array ( "Title" => "Command Name", "SortName" => "command_name"),
		  1 => array ( "Title" => "Command Line", "SortName" => ""),
		  );

# ######## The script REALLY starts running from here ########


# Get Objects Records Count
$objects_count=$Plugin->GetObjectsCount(OBJECTTYPE);

# Get Sorted Object Records
#
# Host Sort Option ($sortoption):
# - "Name"
# - "Alias"
# - "Address"
# - "Inheritance"
# - "Registered"
#
# Sort Type ($sorttype)
#  - 0 - Ascending
#  - 1 - Reversed
#echo "$sortoption, $sorttype";
$objects = $Plugin->GetSortedObjectsFromTo($sortoption, $sorttype, 0, $objects_count, OBJECTTYPE);
#$objects = $Plugin->GetSortedObjects($sortoption, $sorttype, OBJECTTYPE);
#PrintArray($objects);

if (!is_array($objects))	{

	# This message will be displayed in errmsg row in TableHeader
	$message = "No objects found in database.";
	
	OpenTable(4);
	TableHeader($headers, "");
	CloseTable(4);
	include_once("html_wrap/tail.inc.php");
	exit; # If no Records are found, we exit...completly.

}
# we don't need an else, because we exit if there are no records

$i=0;
# Construct $hostdata and $services Arrays for each object found
foreach($objects as $key => $object) {

	$commands[$i]["Id"]=$object["__objectid"];
	$commands[$i]["Command_Name"]=$object[OBJECTTYPE.'_name'];
	$commands[$i]["Command_Line"]=$object['command_line'];
	$i++;
} #foreach

# Get Page information to construct objects to be displayed in the current page, 
# based in DISPLAY_OBJECTS constant var.
$pageinfo=get_objects_from_page(count($commands), $page);

if (DEBUG == "1") debug_window_msg(print_r($pageinfo));


# Construct Table Rows with Selected Host data
$num=$pageinfo["first_object"]+1;
	
for ($i=$pageinfo["first_object"]; $i<$pageinfo["last_object"]; $i++) {

	$rowcolor = ($rowcolor != "dataOdd") ? "dataOdd" : "dataEven";
	
	$rows[]=<<<HTML
<tr class="{$rowcolor}">
  <td>{$num}</td>
  <td>{$commands[$i]["Command_Name"]}</td>
  <td>{$commands[$i]["Command_Line"]}</td>
  <td>
  <a href="commandedit.php?objectid={$commands[$i]["Id"]}" onclick="nw=window.open('', 'edit_command_popup', 'resizable=no, scrollbars=1, copyhistory=0, width=720, height=360');nw.opener=self" target="edit_command_popup">Edit</a>&nbsp;
  <a href="commandview.php?objectid={$commands[$i]["Id"]}" onclick="nw=window.open('', 'view_command_popup', 'resizable=no, scrollbars=1, copyhistory=0, width=720, height=260');nw.opener=self" target="view_command_popup">View</a><br>
  <a href="deleteobject.php?objectid={$commands[$i]["Id"]}&objecttype=command" onclick="nw=window.open('', 'delete_command_popup', 'resizable=no, scrollbars=1, copyhistory=0, width=640, height=230');nw.opener=self" target="delete_command_popup">Delete</a>&nbsp;
  </td>
</tr>
HTML;
	$num++;
} # for

# Draw everything
OpenTable(4);
TableHeader($headers, "");
print implode("\n",$rows);
CloseTable(4);


if (DEBUG == "1") debug_window_msg(print_r($hosts)); # For Debugging

?>
